# This file was generated by liblab | https://liblab.com/

from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel


@JsonMap({})
class ResultsIsbns1(BaseModel):
    """ResultsIsbns1

    :param isbn10: isbn10, defaults to None
    :type isbn10: str, optional
    :param isbn13: isbn13, defaults to None
    :type isbn13: str, optional
    """

    def __init__(self, isbn10: str = None, isbn13: str = None):
        if isbn10 is not None:
            self.isbn10 = isbn10
        if isbn13 is not None:
            self.isbn13 = isbn13


@JsonMap({})
class BookDetails(BaseModel):
    """BookDetails

    :param title: title, defaults to None
    :type title: str, optional
    :param description: description, defaults to None
    :type description: str, optional
    :param contributor: contributor, defaults to None
    :type contributor: str, optional
    :param author: author, defaults to None
    :type author: str, optional
    :param contributor_note: contributor_note, defaults to None
    :type contributor_note: str, optional
    :param price: price, defaults to None
    :type price: str, optional
    :param age_group: age_group, defaults to None
    :type age_group: str, optional
    :param publisher: publisher, defaults to None
    :type publisher: str, optional
    :param primary_isbn13: primary_isbn13, defaults to None
    :type primary_isbn13: str, optional
    :param primary_isbn10: primary_isbn10, defaults to None
    :type primary_isbn10: str, optional
    """

    def __init__(
        self,
        title: str = None,
        description: str = None,
        contributor: str = None,
        author: str = None,
        contributor_note: str = None,
        price: str = None,
        age_group: str = None,
        publisher: str = None,
        primary_isbn13: str = None,
        primary_isbn10: str = None,
    ):
        if title is not None:
            self.title = title
        if description is not None:
            self.description = description
        if contributor is not None:
            self.contributor = contributor
        if author is not None:
            self.author = author
        if contributor_note is not None:
            self.contributor_note = contributor_note
        if price is not None:
            self.price = price
        if age_group is not None:
            self.age_group = age_group
        if publisher is not None:
            self.publisher = publisher
        if primary_isbn13 is not None:
            self.primary_isbn13 = primary_isbn13
        if primary_isbn10 is not None:
            self.primary_isbn10 = primary_isbn10


@JsonMap({})
class ResultsReviews1(BaseModel):
    """ResultsReviews1

    :param book_review_link: book_review_link, defaults to None
    :type book_review_link: str, optional
    :param first_chapter_link: first_chapter_link, defaults to None
    :type first_chapter_link: str, optional
    :param sunday_review_link: sunday_review_link, defaults to None
    :type sunday_review_link: str, optional
    :param article_chapter_link: article_chapter_link, defaults to None
    :type article_chapter_link: str, optional
    """

    def __init__(
        self,
        book_review_link: str = None,
        first_chapter_link: str = None,
        sunday_review_link: str = None,
        article_chapter_link: str = None,
    ):
        if book_review_link is not None:
            self.book_review_link = book_review_link
        if first_chapter_link is not None:
            self.first_chapter_link = first_chapter_link
        if sunday_review_link is not None:
            self.sunday_review_link = sunday_review_link
        if article_chapter_link is not None:
            self.article_chapter_link = article_chapter_link


@JsonMap({})
class GetListsFormatOkResponseResults(BaseModel):
    """GetListsFormatOkResponseResults

    :param list_name: list_name, defaults to None
    :type list_name: str, optional
    :param display_name: display_name, defaults to None
    :type display_name: str, optional
    :param bestsellers_date: bestsellers_date, defaults to None
    :type bestsellers_date: str, optional
    :param published_date: published_date, defaults to None
    :type published_date: str, optional
    :param rank: rank, defaults to None
    :type rank: int, optional
    :param rank_last_week: rank_last_week, defaults to None
    :type rank_last_week: int, optional
    :param weeks_on_list: weeks_on_list, defaults to None
    :type weeks_on_list: int, optional
    :param asterisk: asterisk, defaults to None
    :type asterisk: int, optional
    :param dagger: dagger, defaults to None
    :type dagger: int, optional
    :param amazon_product_url: amazon_product_url, defaults to None
    :type amazon_product_url: str, optional
    :param isbns: isbns, defaults to None
    :type isbns: List[ResultsIsbns1], optional
    :param book_details: book_details, defaults to None
    :type book_details: List[BookDetails], optional
    :param reviews: reviews, defaults to None
    :type reviews: List[ResultsReviews1], optional
    """

    def __init__(
        self,
        list_name: str = None,
        display_name: str = None,
        bestsellers_date: str = None,
        published_date: str = None,
        rank: int = None,
        rank_last_week: int = None,
        weeks_on_list: int = None,
        asterisk: int = None,
        dagger: int = None,
        amazon_product_url: str = None,
        isbns: List[ResultsIsbns1] = None,
        book_details: List[BookDetails] = None,
        reviews: List[ResultsReviews1] = None,
    ):
        if list_name is not None:
            self.list_name = list_name
        if display_name is not None:
            self.display_name = display_name
        if bestsellers_date is not None:
            self.bestsellers_date = bestsellers_date
        if published_date is not None:
            self.published_date = published_date
        if rank is not None:
            self.rank = rank
        if rank_last_week is not None:
            self.rank_last_week = rank_last_week
        if weeks_on_list is not None:
            self.weeks_on_list = weeks_on_list
        if asterisk is not None:
            self.asterisk = asterisk
        if dagger is not None:
            self.dagger = dagger
        if amazon_product_url is not None:
            self.amazon_product_url = amazon_product_url
        if isbns is not None:
            self.isbns = self._define_list(isbns, ResultsIsbns1)
        if book_details is not None:
            self.book_details = self._define_list(book_details, BookDetails)
        if reviews is not None:
            self.reviews = self._define_list(reviews, ResultsReviews1)


@JsonMap({})
class GetListsFormatOkResponse(BaseModel):
    """GetListsFormatOkResponse

    :param status: status, defaults to None
    :type status: str, optional
    :param copyright: copyright, defaults to None
    :type copyright: str, optional
    :param num_results: num_results, defaults to None
    :type num_results: int, optional
    :param last_modified: last_modified, defaults to None
    :type last_modified: str, optional
    :param results: results, defaults to None
    :type results: List[GetListsFormatOkResponseResults], optional
    """

    def __init__(
        self,
        status: str = None,
        copyright: str = None,
        num_results: int = None,
        last_modified: str = None,
        results: List[GetListsFormatOkResponseResults] = None,
    ):
        if status is not None:
            self.status = status
        if copyright is not None:
            self.copyright = copyright
        if num_results is not None:
            self.num_results = num_results
        if last_modified is not None:
            self.last_modified = last_modified
        if results is not None:
            self.results = self._define_list(results, GetListsFormatOkResponseResults)
